<template>
  <el-row :gutter="20">
    <el-col :span="4" :xs="24">
      <ContentWrap class="h-1/1">
        <DeptTree @node-click="handleDeptNodeClick" />
      </ContentWrap>
    </el-col>
    <el-col :span="20" :xs="24">
    <ContentWrap>
      <!-- 搜索工作栏 -->
      <el-form
        class="-mb-15px"
        :model="queryParams"
        ref="queryFormRef"
        :inline="true"
        label-width="68px"
      >
        <el-form-item :label="t('operationFill.name')" prop="orderName" style="margin-left: 15px">
          <el-input
            v-model="queryParams.orderName"
            :placeholder="t('operationFill.nameHolder')"
            clearable
            @keyup.enter="handleQuery"
            class="!w-240px"
          />
        </el-form-item>
        <el-form-item :label="t('operationFill.status')" prop="orderStatus">
          <el-select
            v-model="queryParams.orderStatus"
            :placeholder="t('operationFill.status')"
            clearable
            class="!w-240px"
          >
            <el-option
              v-for="dict in getStrDictOptions(DICT_TYPE.OPERATION_FILL_ORDER_STATUS)"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item :label="t('operationFill.createTime')" prop="createTime" label-width="100px">
          <el-date-picker
            v-model="queryParams.createTime"
            value-format="YYYY-MM-DD HH:mm:ss"
            type="daterange"
            :start-placeholder="t('operationFill.start')"
            :end-placeholder="t('operationFill.end')"
            :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
            class="!w-220px"
          />
        </el-form-item>
        <el-form-item>
          <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" />{{t('operationFill.search')}}</el-button>
          <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" />{{t('operationFill.reset')}}</el-button>
<!--          <el-button-->
<!--            type="primary"-->
<!--            plain-->
<!--            @click="openForm('create')"-->
<!--            v-hasPermi="['rq:iot-inspect-order:create']"-->
<!--          >-->
<!--            <Icon icon="ep:plus" class="mr-5px" /> 新增-->
<!--          </el-button>-->
<!--          <el-button
            type="success"
            plain
            @click="handleExport"
            :loading="exportLoading"
            v-hasPermi="['rq:iot-inspect-order:export']"
          >
            <Icon icon="ep:download" class="mr-5px" /> 导出
          </el-button>-->
        </el-form-item>
      </el-form>
    </ContentWrap>

    <!-- 列表 -->
    <ContentWrap>
      <el-table v-loading="loading" :data="list" :stripe="true"  >
        <el-table-column label="序号" width="60" align="center">
          <template #default="scope">
            {{ scope.$index + 1 }}
          </template>
        </el-table-column>
        <el-table-column :label="t('operationFill.name')" align="center" prop="orderName" width="300"/>
        <el-table-column :label="t('operationFill.duty')" align="center" prop="userName" />
<!--        <el-table-column label="工单类型" align="center" prop="orderType" />-->
        <el-table-column :label="t('operationFill.status')" align="center" prop="orderStatus" >
          <template #default="scope">
            <dict-tag :type="DICT_TYPE.OPERATION_FILL_ORDER_STATUS" :value="scope.row.orderStatus" />
          </template>
        </el-table-column>
<!--        <el-table-column label="备注" align="center" prop="remark" />-->
        <el-table-column
          :label="t('dict.createTime')"
          align="center"
          prop="createTime"
          :formatter="dateFormatter"
        />
        <el-table-column
          label="填写时间"
          align="center"
          prop="updateTime"
          :formatter="dateFormatter"
        />
        <el-table-column :label="t('operationFill.operation')" align="center" min-width="120px">
          <template #default="scope">

              <div v-if="scope.row.orderStatus !== 1">
                <el-button
                  link
                  type="primary"
                  @click="openWrite(scope.row.deptId+','+scope.row.userId+','+scope.row.createTime+','+scope.row.id+','+scope.row.orderStatus)"
                  v-hasPermi="['rq:iot-opeation-fill:update']"
                  v-if="scope.row.orderStatus !== 1"
                >
                  {{t('operationFill.fill')}}
                </el-button>
              </div>
              <div v-else>
                <el-button
                  link
                  type="primary"
                  @click="openWrite(scope.row.deptId+','+scope.row.userId+','+scope.row.createTime+','+scope.row.id+','+0)"
                  v-hasPermi="['rq:iot-opeation-fill:update']"
                  v-if="isSameDay(scope.row.createTime)"
                >
                  {{t('fault.edit')}}
                </el-button>
                <el-button
                  link
                  type="success"
                  @click="openWrite(scope.row.deptId+','+scope.row.userId+','+scope.row.createTime+','+scope.row.id+','+scope.row.orderStatus)"
                >
                  {{t('operationFill.view')}}
                </el-button>
              </div>


            <!-- 编辑按钮 -->


          </template>
        </el-table-column>
      </el-table>
      <!-- 分页 -->
      <Pagination
        :total="total"
        v-model:page="queryParams.pageNo"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
      />
    </ContentWrap>
    </el-col>
  </el-row>
  <!-- 表单弹窗：添加/修改 -->
  <IotInspectOrderForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { IotInspectOrderApi, IotInspectOrderVO } from '@/api/pms/inspect/order'
//import IotInspectOrderForm from './IotInspectOrderForm.vue'
import {DICT_TYPE, getStrDictOptions} from "@/utils/dict";
import DeptTree from "@/views/system/user/DeptTree.vue";
import {IotOpeationFillApi, IotOpeationFillVO} from "@/api/pms/iotopeationfill";
import {useUserStore} from "@/store/modules/user";
const { push } = useRouter()
const { params, name } = useRoute() // 查询参数
const deptId= params.deptId;
const orderStatus = params.orderStatus;
const createTime = params.createTime;
/** 巡检工单 列表 */
defineOptions({ name: 'IotOpeationFill' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<IotOpeationFillVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  inspectOrderTitle: undefined,
  inspectOrderCode: undefined,
  status: undefined,
  remark: undefined,
  createTime: [],
  deptId: useUserStore().getUser.deptId,
  deviceIds: undefined,
  orderStatus:undefined
  //userId:useUserStore().getUser.id
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中


 // 判断两个日期是否为同一天
const isSameDay = (dateString) => {
  if (!dateString) return false

  // 将日期字符串转换为日期对象
  const targetDate = new Date(dateString)
  const today = new Date()

  // 比较年、月、日
  return targetDate.getFullYear() === today.getFullYear() &&
    targetDate.getMonth() === today.getMonth() &&
    targetDate.getDate() === today.getDate()
}


const handleDeptNodeClick = async (row) => {
  queryParams.deptId = row.id
  await getList()
}
/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await IotOpeationFillApi.getIotOpeationFillPage1(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (id?: number) => {
  push({ name: 'InspectOrderDetail', params:{id} })
}

const openWrite = (id?: string) => {
  push({ name: 'FillOrderInfo',params:{id}})
}
/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await IotInspectOrderApi.deleteIotInspectOrder(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await IotInspectOrderApi.exportIotInspectOrder(queryParams)
    download.excel(data, '巡检工单.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  if(deptId != null){

    queryParams.deptId = deptId;
  }
  if(orderStatus === 3){
    queryParams.orderStatus = null
  }
  if(orderStatus != null && orderStatus != 3){
    queryParams.orderStatus = orderStatus;
  }
  if(createTime){
    queryParams.createTime = createTime;
  }
  getList()
})
</script>
